function [a,b,c,auc,tidx] = evalROC(T, R, display)
    %%% evaluate the ROC curve

	%[a, b, c] = roc(T, R) ;
		%% a is false positive rate, b is true positive rate
	[a, b, c, auc, tidx] = perfcurve(T, R, 1, 'NBOOT', 1000);
	[~, idx] = max(b(:,1) - a(:,1)) ;
	tidx = [a(idx) b(idx)] ;
	%keyboard
	%fprintf(['Threshold = ',num2str(c),'\n']) ;
	
	if display
		hold off ;
		plot([0,1], [0,1], 'color', [.8 .8 .8], 'linewidth', 1.2) ;
		set(gca, 'fontsize', 18); axis equal ; axis tight;
		xlabel('False Positive Rate'); ylabel('True Positive Rate');
		hold on ;
		plot(a(:,1), b(:,1), 'color', [.3 .3 .3], 'linewidth', 1.2) ;
		plot(tidx(1), tidx(2), 'ko', 'linewidth', 2, 'MarkerSize', 16) ;
		text(tidx(1)+.02, tidx(2)-.05, ['Sensitivity = ',num2str(0.01*round(100*tidx(2)))], 'fontsize', 18)
		text(tidx(1)+.02, tidx(2)-.1, ['Specificity = ',num2str(1 - 0.01*round(100*tidx(1)))], 'fontsize', 18)
		legend('Random Classifier','ROC Curve', 'Cut-off Point', 'location', 'southeast')
		plot(a(:,1), b(:,1), '.', 'color', [.1 .1 .1], 'linewidth', 2) ;
	
		fprintf(['AUC = ',num2str(round(100*auc(1))/100),' CI = [',num2str(round(100*auc(2))/100),',',num2str(round(100*auc(3))/100),']\n']) ;
	end
end
