close all ; clear

FIG4 = 0 ;

addpath('~/Dropbox/code/Conceft') ;
addpath('~/Dropbox/code/Conceft/tool') ;
addpath('~/Dropbox/code/Conceft/tool/export_fig') ;

scrsz = get(groot,'ScreenSize');

	%% 1:left 2:right 1/2/3: guan-chun-chi
Folder = [11 12 13 21 22 23] ;

BC = 200 ;
K = 6 ;
RR = 10 ;


[h, Dh] = hermf(611, 1, 6) ;



	ii = 14 ; jj = 11 ; kk = 2 ;
	
			%% jj: left/right and guan/chun/chi
		
				%% Q is the folder for different groups
	Q = sprintf(['/Users/hautiengwu/Dropbox/tex20130723/_WORKING_pulse/PulseDataCGMH/Control/N%03d/',num2str(jj)], ii) ;

	ggg = dir([Q,'/*.txt']) ;
    L = [] ; for oo = 1:length(ggg); L(oo) = ggg(oo).bytes ; end
        %% the idx for all files containing signals
    idx = find(L>1e4) ;



	YYY = load([Q,'/',ggg(idx(kk)).name]) ;
	YYY = YYY(1:1000) - mean(YYY(1:1000)) ;
	t = [1:length(YYY)]' / 100 ;
	
	if FIG4
		%rng('default'); 
		rng(111) ;
		e = random('t',3,301,1) ;
		e = e ./ std(e) ;
		noise = armaxfilter_simulate(e, 0, 1, .5, 1, -.3) ;
		YYY(300:600) = YYY(300:600)+ std(YYY)*noise ;
	end

	fprintf(['Length of ',Q(68:end),'/',ggg(idx(kk)).name,' = ',num2str(length(YYY)),'\n']) ;
	[tfr, tfrtic, tfrsq, tfrsq2, tfrsqtic] = sqSTFTbase2nd(YYY, 0, 0.1, 0.0001, 1, h', Dh', dwindow(Dh'), 0) ;
	tfrsq(1:5,:) = 0 ;
	
    bc = CurveExt_M(abs(tfrsq(1:150,:))', .1);
	xhat = zeros(size(YYY)) ;
	
	for oo = 1:length(xhat)
	    xhat(oo) = sum(tfrsq(max(1, bc(oo)-RR): min(size(tfrsq, 2),bc(oo)+RR), oo));
	end
				
	IF = tfrsqtic(bc)*100 ;
	phihat = phase(xhat) ;
	


	[~,qq] = findpeaks(max(200,YYY)) ;
	qq = qq([2 3 5:length(qq)]) ;

	%=======================
					%% plot the result
	hf = figure('Position',[1 scrsz(4) scrsz(3)*2/3 scrsz(4)]) ;
	subplot(3, 16, 1:15) ;
    plot(t(71:930)-t(69), YYY(71:930), 'color', [.0 .0 .0], 'linewidth', 2) ; axis tight; colormap(1-gray) ; hold on;

	if ~FIG4

		for jj = 2:length(qq)-2
			text((qq(jj+1)+qq(jj))/200-0.91, 300, num2str((qq(jj+1)-qq(jj))/100), 'fontsize',24) ; 
			plot(t(qq(jj))-t(69), YYY(qq(jj)), 'o', 'color', [.6 .6 .6], 'linewidth', 2, 'markersize', 20) ;
		end

		plot(t(qq(jj+1))-t(69), YYY(qq(jj+1)), 'o', 'color', [.6 .6 .6], 'linewidth', 2, 'markersize', 20) ;

	end

	set(gca, 'fontsize', 24) ; set(gca, 'ytick', []) ; xlabel('Time (Second)') ;	ylabel('(Arbitrary Unit)') ;


	subplot(3, 16, [17:48]) ;
	tfrsq2 = tfrsq2 ./ quantile(abs(tfrsq2(:)), .9995) ;
	imageSQ(t(71:930)-t(69), tfrsqtic*100, abs(tfrsq2(:, (71:930)).^2), .9995) ;
	%imageSQ(t(71:930)-t(69), tfrsqtic*100, abs(tfrsq(:, (71:930)).^2)) ;
	set(gca, 'fontsize', 24) ;
	axis([-inf inf 0.4 1.6]) ; colormap(1-gray)
	xlabel('Time (Second)') ; ylabel('Frequency (Hz)') ;
colorbar ;
    set(hf,'PaperPositionMode','auto');

	if FIG4
    	saveas(hf, 'Fig4.eps') ;
	else
    	saveas(hf, 'Fig3.eps') ;
	end

