close all ; clear


addpath('~/Dropbox/code/Conceft') ;
addpath('~/Dropbox/code/Conceft/tool') ;
addpath('~/Dropbox/code/Conceft/tool/export_fig') ;

scrsz = get(groot,'ScreenSize');

	%% 1:left 2:right 1/2/3: guan-chun-chi
Folder = [11 12 13 21 22 23] ;

BC = 200 ;
K = 6 ;
RR = 10 ;


[h, Dh] = hermf(611, 1, 6) ;
Rpsi = 477.5212 ; %41.556918012814535 ;


	ii = 2 ; jj = 23 ; kk = 2 ;
	
		
		%% Q is the folder for different groups
	Q = sprintf(['/Users/hautiengwu/Dropbox/tex20130723/_WORKING_pulse/PulseDataCGMH/Treatment/%03d/',num2str(jj)], ii) ;

	ggg = dir([Q,'/*.txt']) ;

        %% determine the signal files
    L = [] ; for oo = 1:length(ggg); L(oo) = ggg(oo).bytes ; end
        %% the idx for all files containing signals
    idx = find(L>1e4) ;

				
	YYY0 = load([Q,'/',ggg(idx(kk)).name]) ;
	%YYY = YYY(1:1000) - mean(YYY(1:1000)) ;
	YYY = YYY0(1:1000) - smooth(YYY0(1:1000), 500, 'loess') ;
	t = [1:length(YYY)]' / 100 ;
	
	fprintf(['Length of ',Q(68:end),'/',ggg(idx(kk)).name,' = ',num2str(length(YYY)),'\n']) ;

	[tfr, tfrtic, tfrsq, tfrsq2, tfrsqtic] = sqSTFTbase2nd(YYY, 0, 0.1, 0.0001, 1, h', Dh', dwindow(Dh'), 0) ;
	tfrsq(1:5,:) = 0 ;
	
	bc = CurveExt_M(abs(tfrsq(1:150,:))', .1);
	xhat = zeros(size(YYY)) ;
	
	for oo = 1:length(xhat)
	    xhat(oo) = sum(tfrsq(max(1, bc(oo)-RR): min(size(tfrsq, 2),bc(oo)+RR), oo));
	end
				
	IF = tfrsqtic(bc)*100 ;
	ahat = abs(xhat)./Rpsi ; 
	phihat = phase(xhat) ;
	
	                %% the shape estimator
	c = zeros(length(phihat), K*2+1);
	Q = zeros(200, K*2 +1) ;
	tt = linspace(0,1,200) ;
    for pp = 1:K
	    c(:, (pp-1)*2+1) = ahat .* cos(pp*phihat);
	    c(:, (pp-1)*2+2) = ahat .* sin(pp*phihat);
	    Q(:, (pp-1)*2+1) = cos(2*pi*pp*tt);
	    Q(:, (pp-1)*2+2) = sin(2*pi*pp*tt);
	end
	c(:, end) = ahat ;
	Q(:, end) = ones(200,1) ;
	
	hatshat = (YYY((BC+1:1000-BC),:)' * c((BC+1:1000-BC),:)) * inv(c((BC+1:1000-BC),:)'*c((BC+1:1000-BC),:));
	shat = hatshat(1:K*2+1) * c' ;
	
	PS = zeros(K+1) ;
	for pp = 1: K
		PS(pp) = hatshat((pp-1)*2+1).^2+hatshat(pp*2).^2;
	end
	PS(K+1) = hatshat(end).^2 ;			

    [~,qq]=findpeaks(max(30,YYY)) ;
    qq = qq([2 3 5:length(qq)]) ;



%=======================
		%% plot the result
	hf = figure('Position',[1 scrsz(4)/2 scrsz(3) scrsz(4)]) ;

	subplot(3, 3, [1:2]) ;
    plot(t(71:930)-t(69), YYY(71:930), 'k', 'linewidth', 2) ; hold on ;
%{
    for jj = 2:length(qq)-2
        text((qq(jj+1)+qq(jj))/200-0.91, 300, num2str((qq(jj+1)-qq(jj))/100), 'fontsize',24) ;
        plot(t(qq(jj))-t(69), YYY(qq(jj)), 'o', 'color', [.6 .6 .6], 'linewidth', 2, 'markersize', 20) ;
    end
    plot(t(qq(jj+1))-t(69), YYY(qq(jj+1)), 'o', 'color', [.6 .6 .6], 'linewidth', 2, 'markersize', 20) ;
%}
	axis tight; colormap(1-gray)

	set(gca, 'fontsize', 24) ; set(gca, 'ytick', []) ; 
	xlabel('Time (Second)') ; ylabel('(Arbitrary Unit)') ; title('(a)') ;
	SS = hatshat * Q' ;

	subplot(3, 3, 6) ; 
	plot(tt, SS([121:200 1:120]), 'k', 'linewidth', 2) ;
	set(gca, 'fontsize', 24) ; set(gca, 'ytick', []) ; axis tight ; 
	set(gca, 'xtick', []) ; title('(b)') ;

	subplot(3, 3, [4:5 7:8]) ;
	imageSQ(t(71:930)-t(69), tfrsqtic*100, abs(tfrsq2(:, (71:930)).^2), .9992) ;
	set(gca, 'fontsize', 24) ;
    axis([-inf inf 0.4 1.6]) ; colormap(1-gray)
	xlabel('Time (Second)') ; ylabel('Frequency (Hz)') ; 
	text(4.1, 1.52, '(c)', 'fontsize', 30) ;



	subplot(3, 3, 9) ;
	bar([1:K], PS(1:K)) ; axis tight ; set(gca, 'ytick',[]) ;
	set(gca, 'fontsize', 24) ;
	title('(d)') ; xlabel('Frequency (Hz)') ;
	
	%subplot(3, 3, 3) ;
	%xhat = fft(YYY) ./ 100 ; xi = [1/10:1/10:50]' ;
	%bar(xi(1:100), abs(xhat(2:101)).^2) ; axis tight ; 
	%set(gca, 'ytick',[]) ; set(gca, 'fontsize', 24) ;
	%title('(e)') ; xlabel('Frequency (Hz)') ;

	set(hf,'PaperPositionMode','auto');
    saveas(hf, 'Fig6.eps') ;

