close all; clear

Position = {'Guan','Chun','Chi'} ;

dataLeft = [] ; dataRight = [] ;
dataLeft0 = [] ; dataRight0 = [] ;
nLeft = 0 ; nRight = 0 ;

h0 = figure ;
h1 = figure ;
% ========== prepare data

	%% 1/2/3 kuan/chun/chi
for ii = 1 : 3
 
	load rsltTreatment
	eval(['dataT0 = [rslt1',num2str(ii),' rslt2',num2str(ii),'];']) ;
	eval(['n1T = size(rslt1',num2str(ii),', 2) ;']) ;
	eval(['n2T = size(rslt2',num2str(ii),', 2) ;']) ;
	nT = n1T + n2T ;
	
		%% remove the DC term
	%dataT0 = dataT0(1:end-1, :) ;

	D = (size(dataT0,1)-1)/2 ;

	dataT = zeros(D+1, size(dataT0,2)) ; NormT = zeros(nT, 1) ;
	for ll = 1: nT ; 
		dataT(:, ll) = [sqrt(dataT0(1:2:2*D,ll).^2+dataT0(2:2:2*D,ll).^2) ; dataT0(end, ll)] ;
		NormT(ll) = norm(dataT0(:,ll)) ; 
		%dataT0(:, ll) = dataT0(:, ll) ./ NormT(ll) ;
	end


	load rsltControl
	eval(['dataC0 = [rslt1',num2str(ii),' rslt2',num2str(ii),'];']) ;
	eval(['n1C = size(rslt1',num2str(ii),', 2) ;']) ;
	eval(['n2C = size(rslt2',num2str(ii),', 2) ;']) ;
	nC = n1C + n2C ;

	%dataC0 = dataC0(1:end-1, :) ;

    dataC = zeros(D+1, size(dataC0,2)) ; NormC = zeros(nC, 1) ;
    for ll = 1: nC ; 
		dataC(:, ll) = [sqrt(dataC0(1:2:2*D,ll).^2+dataC0(2:2:2*D,ll).^2) ; dataC0(end, ll)] ;
		NormC(ll) = norm(dataC0(:,ll)) ; 
		%dataC0(:, ll) = dataC0(:, ll) ./ NormC(ll) ;
	end



	fprintf(['\n',Position{ii},': CHF case = ',num2str(n1T),'; Control case = ',num2str(n1C),'\n']) ;
	



    fprintf(['Norm of Normal/CHF = ',num2str(mean(NormC)),'+-',num2str(std(NormC)),' / ',num2str(mean(NormT)),'+-',num2str(std(NormT)),'\n']) ;








	%=============
		% plot SPS comparison (left hand only)
	meanC = mean(dataC(:, 1:n1C),2) ; stdC = zeros(size(dataC(:, 1:n1C),1),1) ;
	meanC0 = mean(dataC0(:, 1:n1C),2) ; stdC0 = zeros(size(dataC0(:, 1:n1C),1),1) ;
	meanT = mean(dataT(:, 1:n1T),2) ; stdT = zeros(size(dataT(:, 1:n1T),1),1) ;
	meanT0 = mean(dataT0(:, 1:n1T),2) ; stdT0 = zeros(size(dataT0(:, 1:n1T),1),1) ;
	for ll = 1: length(meanC); stdC(ll) = std(dataC(ll, 1:n1C)) ; stdT(ll) = std(dataT(ll, 1:n1T)) ; end
	for ll = 1: length(meanC0); stdC0(ll) = std(dataC0(ll, 1:n1C)) ; stdT0(ll) = std(dataT0(ll, 1:n1T)) ; end

	figure ; 
	errorbar([1:size(dataT,1)], meanT, stdT, 'k', 'linewidth', 2) ; hold on;
	errorbar([1:size(dataC,1)]-.1, meanC, stdC, 'color', [.5 .5 .5],  'linewidth', 2) ; axis tight ;
	set(gca, 'fontsize', 18) ; 
	title(['Control: Left ',Position{ii}]) ;
	%set(gca,'xtick',[1:7]) ;
	%set(gca,'xticklabel',{'\alpha_1','\alpha_2','\alpha_3','\alpha_4','\alpha_5','\alpha_6','\beta_1','\beta_2','\beta_3','\beta_4','\beta_5','\beta_6','\alpha_0'})

	figure;
	errorbar([1:size(dataT0,1)], meanT0([1:2:size(dataT0,1) 2:2:size(dataT0,1)]), stdT0([1:2:size(dataT0,1) 2:2:size(dataT0,1)]), 'k', 'linewidth', 2) ; hold on;
	errorbar([1:size(dataC0,1)]-.1, meanC0([1:2:size(dataT0,1) 2:2:size(dataT0,1)]), stdC0([1:2:size(dataT0,1) 2:2:size(dataT0,1)]), 'color', [.5 .5 .5],  'linewidth', 2) ; axis tight ;
	set(gca, 'fontsize', 18) ; 
	set(gca,'xtick',[1:13]) ;
	set(gca,'xticklabel',{'\alpha_1','\alpha_2','\alpha_3','\alpha_4','\alpha_5','\alpha_6','\beta_1','\beta_2','\beta_3','\beta_4','\beta_5','\beta_6','\alpha_0'})



	%================
		%% check if functions are different
	CHF = zeros(size(dataT0,1)+1, size(dataT0,2));
	CHF(1, :) = 1 ;
	CHF(2:size(dataT0,1)+1, :) = dataT0 ;
	Control = zeros(size(dataC0,1)+1, size(dataC0,2));
	Control(1, :) = 0 ;
	Control(2:size(dataC0,1)+1, :) = dataC0 ;

	%fprintf(['Fmax for ',Position{ii},', both\t']);
	%[pstat, params, gsize, vmu] = fanova1w([CHF'; Control'], [5, 10000]) ;
	%fprintf(['(Fmax) CHF vs Control p = ',num2str(pstat(2)),'\n']);

	fprintf(['GFP for ',Position{ii},', both\t']);
	[pstat, params, gsize, vmu] = fanova1w([CHF'; Control'], 3) ;
	fprintf(['CHF vs Control p = ',num2str(pstat(2)),'\n']);





    CHF = zeros(size(dataT0(:, 1:n1C),1)+1, size(dataT0(:, 1:n1C),2));
    CHF(1, :) = 1 ;
    CHF(2:size(dataT0(:, 1:n1C),1)+1, :) = dataT0(:, 1:n1C) ;
    Control = zeros(size(dataC0(:, 1:n1C),1)+1, size(dataC0(:, 1:n1C),2));
    Control(1, :) = 0 ;
    Control(2:size(dataC0(:, 1:n1C),1)+1, :) = dataC0(:, 1:n1C) ;

    %fprintf(['Fmax for ',Position{ii},', left\t']);
    %[pstat, params, gsize, vmu] = fanova1w([CHF'; Control'], [5, 10000]) ;
    %fprintf(['(Fmax) CHF vs Control p = ',num2str(pstat(2)),'\n']);

    fprintf(['GFP for ',Position{ii},', left\t']);
    [pstat, params, gsize, vmu] = fanova1w([CHF'; Control'], 3) ;
    fprintf(['CHF vs Control p = ',num2str(pstat(2)),'\n']);






	CHF = zeros(size(dataT0(:, n1C+1:end),1)+1, size(dataT0(:, 1+n1C:end),2));
    CHF(1, :) = 1 ;
    CHF(2:size(dataT0(:, 1+n1C:end),1)+1, :) = dataT0(:, 1+n1C:end) ;
    Control = zeros(size(dataC0(:, 1+n1C:end),1)+1, size(dataC0(:, 1+n1C:end),2));
    Control(1, :) = 0 ;
    Control(2:size(dataC0(:, 1+n1C:end),1)+1, :) = dataC0(:, 1+n1C:end) ;

    %fprintf(['Fmax for ',Position{ii},', right\t']);
    %[pstat, params, gsize, vmu] = fanova1w([CHF'; Control'], [5, 10000]) ;
    %fprintf(['(Fmax) CHF vs Control p = ',num2str(pstat(2)),'\n']);

    fprintf(['GFP for ',Position{ii},', right\t']);
    [pstat, params, gsize, vmu] = fanova1w([CHF'; Control'], 3) ;
    fprintf(['CHF vs Control p = ',num2str(pstat(2)),'\n']);



%==================================
		% X1 is the left hand, X2 is the right hand
	XLeft = [dataT0(:, 1:n1T) dataC0(:, 1:n1C)]' ;
	XRight = [dataT0(:, n1T+1:end) dataC0(:, n1C+1:end)]' ;
	
	o1 = [0*ones(1, n1T) ones(1,n1C)]' ;
	o2 = [0*ones(1, n2T) ones(1,n2C)]' ;
	


		%% left hand
	[n1, p1] = size(XLeft) ;
	[Xloadings,Yloadings,Xscores,Yscores,betaPLS,varPC] = plsregress(XLeft, o1, 2);
	yfitPLS1 = [ones(n1,1) XLeft]*betaPLS;
	figure(h1) ; subplot(1,3,ii); plot(betaPLS, 'k') ;

	[a1,b1,c1,auc1,tidx1] = evalROC(o1, yfitPLS1, 0) ; 
	idxJ1 = find(b1(:,1)==tidx1(2)) ; idxK1 = find(a1(:,1)==tidx1(1)) ; idxL1 = intersect(idxJ1, idxK1) ;
	Threshold1 = c1(idxL1(1)) ; auc1 = round(auc1*100)/100 ; tidx1 = round(tidx1*100)/100 ; 

	
		%% right hand
	[n2, p2] = size(XRight) ;
	[Xloadings,Yloadings,Xscores,Yscores,betaPLS,varPC] = plsregress(XRight, o2, 2);
	yfitPLS2 = [ones(n2,1) XRight]*betaPLS;
	figure(h1) ; subplot(1,3,ii); hold on; plot(betaPLS, 'color', [.6 .6 .6]) ; axis tight ;

	[a2,b2,c2,auc2,tidx2] = evalROC(o2, yfitPLS2, 0) ; 
	idxJ2 = find(b2(:,1)==tidx2(2)) ; idxK2 = find(a2(:,1)==tidx2(1)) ; idxL2 = intersect(idxJ2, idxK2) ;
	Threshold2 = c2(idxL2(1)) ; auc2 = round(auc2*100)/100 ; tidx2 = round(tidx2*100)/100 ;



	fprintf(['\tThrd for left ',Position{ii},' = ',num2str(Threshold1),';\n']) ;
	fprintf(['\t\tAUC = ',num2str(auc1(1)),' CI = [',num2str(auc1(2)),',',num2str(auc1(3)),']\n']) ;
	fprintf(['\t\tAccuracy = ',num2str((length(find((yfitPLS1(1:n1T)<Threshold1))) +  length(find(yfitPLS1(n1T+1:end)>=Threshold1))) ./ n1),'\n']) ;

	fprintf(['\tThrd for right ',Position{ii},' = ',num2str(Threshold2),';\n']) ;
	fprintf(['\t\tAUC = ',num2str(auc2(1)),' CI = [',num2str(auc2(2)),',',num2str(auc2(3)),']\n']) ;
	fprintf(['\t\tAccuracy = ',num2str((length(find((yfitPLS2(1:n2T)<Threshold2))) +  length(find(yfitPLS2(n2T+1:end)>=Threshold2))) ./ n2),'\n']) ;


	figure; 
    plot([0,1], [0,1], 'color', [.8 .8 .8], 'linewidth', 2) ;
    set(gca, 'fontsize', 20); axis equal ; axis tight;
    xlabel('False Positive Rate'); ylabel('True Positive Rate');
    hold on ;
    plot(a1(:,1), b1(:,1), 'color', [.0 .0 .0], 'linewidth', 4) ;
    plot(tidx1(1), tidx1(2), 'o', 'color', [.0 .0 .0], 'linewidth', 3, 'MarkerSize', 16) ;
    text(.5, .3, ['Sensitivity = ',num2str(tidx1(2))], 'color', [.0 .0 .0], 'fontsize', 22)
    text(.5, .25, ['Specificity = ',num2str(1-tidx1(1))], 'color', [.0 .0 .0], 'fontsize', 22)

    plot(a2(:,1), b2(:,1), 'color', [.7 .7 .7], 'linewidth', 4) ;
    plot(tidx2(1), tidx2(2), 'o', 'color', [.7 .7 .7], 'linewidth', 3, 'MarkerSize', 16) ;
    text(.5, .15, ['Sensitivity = ',num2str(tidx2(2))], 'color', [.6 .6 .6], 'fontsize', 22)
    text(.5, .1, ['Specificity = ',num2str(1-tidx2(1))], 'color', [.6 .6 .6], 'fontsize', 22)





%================================
	%% cross validation

if 0
        %% left hand
    [n1, p1] = size(XLeft) ;
	Qacc = 0 ;
	for cc = 1:n1
		Qidx = cc ; QLeft = XLeft([1:Qidx-1 Qidx+1:n1],:) ;
		Qo1 = o1([1:Qidx-1 Qidx+1:n1]) ;
    	[Qloadings,Qloadings,Qscores,Qscores,QbetaPLS,QvarPC] = plsregress(QLeft, Qo1, 2);
    	QyfitPLS1 = [ones(n1-1,1) QLeft]*QbetaPLS;

    	[a1Q,b1Q,c1Q,auc1Q,tidx1Q] = evalROC(Qo1, QyfitPLS1, 0) ;
    	idxJ1Q = find(b1Q(:,1)==tidx1Q(2)) ; idxK1Q = find(a1Q(:,1)==tidx1Q(1)) ; idxL1Q = intersect(idxJ1Q, idxK1Q) ;
    	Threshold1Q = c1Q(idxL1Q(1)) ; 
		if (([1 XLeft(Qidx,:)]*QbetaPLS > Threshold1Q ) & o1(Qidx)==1) | (([1 XLeft(Qidx,:)]*QbetaPLS <= Threshold1Q ) & o1(Qidx)==0)
			Qacc = Qacc + 1 ;
		end
	end
	fprintf(['** Cross validation for left ',Position{ii},': ',num2str(Qacc/n1),'\n']) ;


        %% right hand
    [n2, p2] = size(XRight) ;
	Qacc = 0 ;
	for cc = 1:n2
        Qidx = cc ; QRight = XRight([1:Qidx-1 Qidx+1:n2],:) ;
        Qo2 = o2([1:Qidx-1 Qidx+1:n2]) ;
        [Qloadings,Qloadings,Qscores,Qscores,QbetaPLS,QvarPC] = plsregress(QRight, Qo2, 2);
        QyfitPLS2 = [ones(n2-1,1) QRight]*QbetaPLS;

        [a2Q,b2Q,c2Q,auc2Q,tidx2Q] = evalROC(Qo2, QyfitPLS2, 0) ;
        idxJ2Q = find(b2Q(:,1)==tidx2Q(2)) ; idxK2Q = find(a2Q(:,1)==tidx2Q(1)) ; idxL2Q = intersect(idxJ2Q, idxK2Q) ;
        Threshold2Q = c2Q(idxL2Q(1)) ;
        if (([1 XRight(Qidx,:)]*QbetaPLS > Threshold2Q ) & o2(Qidx)==1) | (([1 XRight(Qidx,:)]*QbetaPLS <= Threshold2Q ) & o2(Qidx)==0)
            Qacc = Qacc + 1 ;
        end 
    end
    fprintf(['** Cross validation for right ',Position{ii},': ',num2str(Qacc/n2),'\n']) ;

end



%================================
	%% plot the histogram of GPS
figure(h0) ;
if ii == 1; qq = 2; elseif ii == 2; qq = 1; elseif ii == 3; qq= 3 ; end
subplot(2, 3, qq) ;
G=-5*ones(max(n1C,n1T),2);
G(1:n1T,1) = yfitPLS1(1:n1T) ; G(1:n1C,2) = yfitPLS1(n1T+1:n1T+n1C);
hist(G,40) ; axis([min(yfitPLS1) max(yfitPLS1) 0 inf])
h = findobj(gca,'Type','patch');
h(1).FaceColor = [0.8 0.8 0.8] ; h(2).FaceColor = [0 0 0] ;
hold on; plot(Threshold1, 15, 'p', 'color', [.3 .3 .3], 'linewidth',5,'markersize',20)
set(gca,'fontsize', 20) ; xlabel('GPS') ; 

subplot(2, 3, qq+3) ;
G=-5*ones(max(n2C,n2T),2);
G(1:n2T,1) = yfitPLS2(1:n2T) ; G(1:n2C,2) = yfitPLS2(n2T+1:n2T+n2C);
hist(G,40) ; axis([min(yfitPLS2) max(yfitPLS2) 0 inf])
h = findobj(gca,'Type','patch');
h(1).FaceColor = [0.8 0.8 0.8] ; h(2).FaceColor = [0 0 0] ;
hold on; plot(Threshold2, 15, 'p', 'color', [.3 .3 .3], 'linewidth',5,'markersize',20)
set(gca,'fontsize', 20) ; xlabel('GPS') ; 


end
	
	
	


	%% test differnt positions on the control group
load rsltControl
 
D11 = zeros(size(rslt11,1)+1, size(rslt11,2)) ; D11(1,:) = 1 ; D11(2:end, :) = rslt11 ; 
D12 = zeros(size(rslt12,1)+1, size(rslt12,2)) ; D12(1,:) = 2 ; D12(2:end, :) = rslt12 ; 
D13 = zeros(size(rslt13,1)+1, size(rslt13,2)) ; D13(1,:) = 3 ; D13(2:end, :) = rslt13 ; 
D21 = zeros(size(rslt21,1)+1, size(rslt21,2)) ; D21(1,:) = 4 ; D21(2:end, :) = rslt21 ; 
D22 = zeros(size(rslt22,1)+1, size(rslt22,2)) ; D22(1,:) = 5 ; D22(2:end, :) = rslt22 ; 
D23 = zeros(size(rslt23,1)+1, size(rslt23,2)) ; D23(1,:) = 6 ; D23(2:end, :) = rslt23 ; 

fprintf(['Fmax \n']);
[pstat, params, gsize, vmu] = fanova1w([D11'; D12'; D13'; D21'; D22'; D23'], [5, 10000]) ;
fprintf(['(Fmax) all positions, p = ',num2str(pstat(2)),'\n']);
[pstat, params, gsize, vmu] = fanova1w([D11'; D12'; D13'], [5, 10000]) ;
fprintf(['(Fmax) left positions, p = ',num2str(pstat(2)),'\n']);
[pstat, params, gsize, vmu] = fanova1w([D21'; D22'; D23'], [5, 10000]) ;
fprintf(['(Fmax) right positions, p = ',num2str(pstat(2)),'\n']);

fprintf(['GFP \n']);
[pstat, params, gsize, vmu] = fanova1w([D11'; D12'; D13'; D21'; D22'; D23'], 3) ;
fprintf(['(GFP) all positions, p = ',num2str(pstat(2)),'\n']);
[pstat, params, gsize, vmu] = fanova1w([D11'; D12'; D13'], 3) ;
fprintf(['(GFP) left positions, p = ',num2str(pstat(2)),'\n']);
[pstat, params, gsize, vmu] = fanova1w([D21'; D22'; D23'], 3) ;
fprintf(['(GFP) right positions, p = ',num2str(pstat(2)),'\n']);

  

